-- Rune Use plugin by David Down
-- coding: utf-8 'ä
import "Turbine.Gameplay"
import "Vinny.Common"
import "Vinny.Common.EII_ID"
import "Vinny.Common.Help"
import "Vinny.RuneUse.RU_Data"

function print(text) Turbine.Shell.WriteLine("<rgb=#00FFFF>RU:</rgb> "..text) end
function printh(text) print("<rgb=#00FF00>"..text.."</rgb>") end
function printw(text) print("<rgb=#FFFF00>"..text.."</rgb>") end
function printe(text) print("<rgb=#FF6040>Error: "..text.."</rgb>") end

local RUv = "Rune Use "..Plugins["RuneUse"]:GetVersion()
local npat = "+(%d), Lvl (%d+)"
local xpat = "<Examine:IIDDID:0x0%x+:0x700(%x+)>%[(.-)%]<\\Examine>"
xlink = "<Examine:IIDDID:0x0000000000000000:0x700%s>[%s]<\\Examine>"

player = Turbine.Gameplay.LocalPlayer.GetInstance()
pname = player:GetName()
if pname:sub(1,1)=="~" then
	printe("Session Play detected.")
	return
end
plevel = player:GetLevel()

RU_Settings = Turbine.PluginData.Load(Turbine.DataScope.Server,"RU_Settings")
local save
if type(RU_Settings) ~= "table" then
	RU_Settings = { player={} }
    printh(RUv.." Settings initialized.")
	save = true
else printh(RUv.." Settings loaded.") end
Pset = RU_Settings.player[pname]
EL, NL = 0, 999
if plevel>44 then
	for lvl,n in pairs(Enh) do
		if plevel>=lvl and EL<n then EL = n end
		if plevel<lvl and NL>lvl then NL = lvl end
	end
	if not Pset then
		Pset = {l=plevel, el=EL, lt=EL }
		RU_Settings.player[pname] = Pset
		if not save then print("Added settings for "..pname) end
		save = true
	else 
		save = Pset.l < plevel
		Pset.l = plevel 
		Pset.el = EL
	end
	for n,t in pairs(RU_Settings.player) do
		if t.me then t.el=t.me; t.me=nil; save=true end
	end
	if save then 
		Turbine.PluginData.Save(Turbine.DataScope.Server,"RU_Settings",RU_Settings) 
	end
end

import "Vinny.RuneUse.RU_Window"
Plugins.RuneUse.Open = function(sender,args)
	RU_window:SetVisible( true )
	RU_window:SetZOrder( 2 )
end

if EL>0 then 
	print("For a level "..plevel.." player, the enhancement limit is "..EL)
	print("If your legendary weapon item level is less than "..EL..
			", you can reforge it now.")
	if NL==999 then printw("This is the highest reforge available.")
	else 
		local s,si = '.', Slots[NL]
		if si then 
			s=", adding "..si:sub(1,1).." Word of "..Tnamw[si:sub(2)].." slots."
		end
		print("The next reforge can be made at level "..NL..s)
	end
	if Pset.lt==Pset.el and not save then
		printw("You can't use any runes until you reforge.")
	end
	local el,bid,rel = 999
	for id,r in pairs(Rune) do
		rel = EnhL[r.l]
		if rel>Pset.lt and rel<el and r.l<=plevel and r.t=='U' then 
			bid = id
			el = rel
		end
	end
	if bid then
		local lvl = Rune[bid].l
		if lvl==45 then lvl = 50 end
		local xname = string.format(xlink,bid,"Enhancement Rune +1, Lvl "..lvl)
		print("The lowest usable rune is "..xname)
	end
	el = 999
	for l in pairs(Rem) do
		if l<el and l>plevel then el = l end
	end
	if el<999 then print("New traceries are available at level "..el)
	else print("You have the highest level of traceries.") end
else printe("You must be at least level 45 to use Runes.") end

-- Player index, sorted by level
plist = {}
pn = RU_Settings.player
for name in pairs(pn) do
	table.insert(plist,name)
end
table.sort(plist,function(a,b) return pn[a].l>pn[b].l end)

-- Display a Rune item 
function RU_Item(id)
	local rd = Rune[id]
	if not rd then printe("Unknown rune, tracery or essence.") return end
	local rel = EnhL[rd.l]
	print(Tname[rd.t].." Enchantment Rune, Lvl "..rd.l..", limit="..rel)
	local use,reforge = false
	if Pset then
--		print("l="..plevel..", lt="..Pset.lt..", el="..Pset.el)
		if rel <= Pset.lt then
			print("This rune is too low level for you to use.")
		elseif rd.l <= plevel and Pset.lt < Pset.el then
			printh("You can use this rune now."); use = true
		elseif rd.l <= NL then
			printw("You can use this rune after a reforge at level "..NL)
			reforge = true
		else print("This rune to too high level to be used any time soon.") end
		if not use then
			local blt,bname = 999
			for ix,name in ipairs(plist) do
				local s=pn[name]
				if s.l>=rd.l and rel>s.lt and s.lt<blt then
					if s.lt==s.el then reforge = true
					else bname = name; blt = s.lt end
				end
			end
			if bname then
				print(bname.." can best use this rune.")
			elseif reforge then print("None can use this rune until they reforge.")
		else print("None can use this rune until level "..rd.l) end
		end
		return use
	end
end

RU_Command = Turbine.ShellCommand()

-- Main command processing
function RU_Command:Execute( cmd,args )
	if cmd=="ru?" then
		Vinny.Common.Help(help,"??")
		return
	end
	if args=="help" or args=="?" then
		Vinny.Common.Help(help,args)
		return
	end
	if cmd=="ruw" or args=="show" then
		if plevel<45 then print("Warning: Too low a level for Runes.") end
		RU_window:SetVisible( true ) 
		return
	end
	if cmd=="rub" then
		printh("Checking bags for runes:")
		local list,found = {}
		bag =  player:GetBackpack()
		local ti,cnt = {}, bag:GetSize()
		for i=0,cnt do 
			local item = bag:GetItem(i)
			if item then
				local info = item:GetItemInfo()
				local name = info:GetName()
				local cat = info:GetCategory()
				local ri,lvl = name:match(npat)
				if cat==ERC and lvl then
					local nr = item:GetQuantity()
					RU_window.Slot:SetShortcut(Turbine.UI.Lotro.Shortcut(item))
					if Pset then
						rl = tonumber(lvl)
						if rl==50 then rl = 45 end
					end
					local bid = Rix[rl][Et[tonumber(ri)]]
					print(string.format(xlink,bid,nr.." Enhancement Runes +"..ri..", Lvl "..lvl))
					found = true
				end
			end
		end
		if not found then print("(none found)") end
		return
	end
	if cmd=="rud" then
		if pn[args] then
			pn[args] = nil
			for ix,name in ipairs(plist) do
				if name==args then table.remove(plist,ix) end
			end
			print("Deleted "..args.." from list.")
			Turbine.PluginData.Save(Turbine.DataScope.Server,"RU_Settings",RU_Settings) 
		else printe(args.." is unknown.") end
		return
	end
	if args=="list" then
		printh("Known player settings:")
		for ix,name in ipairs(plist) do
			local s=pn[name]
			if s.l>44 then print(name..'('..s.l.."), EL="..s.el..", LT="..s.lt) end
		end
		return
	end
	if args=="reforge" then
		printh("Legendary items can be reforged at level/new item level:")
		local ix = {}
		for l in pairs(Enh) do table.insert(ix,l) end
		table.sort(ix)
		for i,l in ipairs(ix) do
			print(l..'/'..Enh[l])
		end
		return
	end
	if args=="slots" then
		local lvl,si = 999
		for l,s in pairs(Slots) do
			if l<lvl and l>plevel then lvl=l; si=s end
		end
		if lvl<999 then
			print(si:sub(1,1).." Word of "..Tnamw[si:sub(2)]..
				" slots will be added with a reforge at level "..lvl..".")
		else printw("You have the maximum number of tracery slots.") end
		return
	end

	local id,name = args:match(xpat)
	if not id then id,name = Vinny.Common.EII_ID(args) end
	if id then
        if Rune[id] then RU_Item(id)
		elseif Chest[id] then
			local ct,rl = Chest[id],0
			for l,el in pairs(EnhL) do
				if l>rl and l<=plevel then rl = l end
			end
			local rid = Rix[rl][ct]
			if rl<50 then rl = 50 end
			str = string.format(xlink,rid,"Enhancement Rune +"..Enr[ct]..", Lvl "..rl)
			print("A level "..plevel.." player will receive "..str)
        else printe("Unknown item, "..name) end
        return
    end
    Vinny.Common.Help(help,args)
end

Turbine.Shell.AddCommand( "ru;rub;rud;ruw;ru?",RU_Command )

-- Options panel
import "Vinny.Common.Options"
Vinny.Common.Options_Init(print,RU_Settings,RU_window,"RU_Settings")

-- Help text
help = {
	pre = "RU",
	help = "Enter '/ru ?' for possible arguments",
	['?'] = "Unknown, enter '/ru ?'",
	arg = {
		list = "list known characters and their saved settings.",
		show = "Open Rune Use window.",
		reforge = "List the levels for reforging.",
		slots = "Show next tracery slot addition.",
		["<link>"] = "Check Rune use for <link>",
	},
	cmd = {
		rub = "List runes found in bags.",
		rud = "Delete <name> from list.",
		ruw = "Open Rune Use window.",
	},
}
